	--alter table INGRESO_EQUIPOS ADD CHECK (INGRESO_CANTIDAD>'0');
	--alter table ASIGNACION ADD CHECK (ASIGNACION_CANTIDAD>'0');
	--alter table DEVOLUCION ADD CHECK (DEVOLUCION_CANTIDAD>'0');
	
 
/*
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
-----------------PROCEDIMIENTO: TRANSACCION EQUIPOS (INGRESO)----------------
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
*/
CREATE OR REPLACE PROCEDURE public.ingreso_equipos (integer, integer, integer, date)
LANGUAGE 'plpgsql' AS $BODY$
DECLARE 
	 N1 int;
	BEGIN
		INSERT INTO INGRESO_EQUIPOS (ORIGEN_ID, EQUIPOS_ID, INGRESO_CANTIDAD, INGRESO_FECHA) VALUES ($1, $2, $3, $4);

		IF ($3 > 0 ) THEN 
			UPDATE EQUIPOS SET EQUIPOS_CANTIDAD=EQUIPOS_CANTIDAD+$3 WHERE EQUIPOS_ID = $2;
		ELSE 
			RAISE EXCEPTION 'DEBE INGRESAR UNA CANTIDAD';
		END IF;		
		
	EXCEPTION
		WHEN SQLSTATE '23514' THEN
		RAISE EXCEPTION 'ERROR AL INGRESAR LOS EQUIPOS';
		ROLLBACK;
	COMMIT;
END;
$BODY$;

--CALL ingreso_equipos2 ('1', '5', '0', '2021-05-12');

/*
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
-----------------PROCEDIMIENTO: TRANSACCION EQUIPOS (ASIGNACION)----------------
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
*/

CREATE OR REPLACE PROCEDURE public.asignacion_equipos (integer, integer, integer, date)
LANGUAGE 'plpgsql' AS $BODY$
DECLARE 
	 N1 int;
	BEGIN
		INSERT INTO ASIGNACION (EQUIPOS_ID, BOMBERO_ID, ASIGNACION_CANTIDAD, ASIGNACION_FECHA,ASIGNACION_ESTADO) VALUES ($1, $2, $3, $4,'ASIGNADO');
		SELECT EQUIPOS_CANTIDAD INTO N1 FROM EQUIPOS WHERE EQUIPOS.EQUIPOS_ID = $1;
		
		IF (N1 = 0) THEN
			RAISE EXCEPTION 'EL EQUIPO SELECCIONADO SE ENCUENTRA AGOTADO';
		END IF;
		IF ($3 = 0) THEN
			RAISE EXCEPTION 'DEBE ASIGNAR UNA CANTIDAD PARA LA ASIGNACION DEL EQUIPO';
		END IF;
		IF ($3 <= N1) THEN
			UPDATE EQUIPOS SET EQUIPOS_CANTIDAD=EQUIPOS_CANTIDAD-$3 WHERE EQUIPOS_ID = $1;
		ELSE
			RAISE EXCEPTION 'NO HAY SUFICIENTES EQUIPOS PARA ASIGNAR';
		END IF;
	EXCEPTION
		WHEN SQLSTATE '23514' THEN
		RAISE EXCEPTION 'ERROR AL ASIGNAR EL EQUIPO';
		ROLLBACK;
	COMMIT;
END;
$BODY$;

--CALL asignacion_equipos (22, '05', '1003', '0', '2021-05-12');


/*
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
-----------------PROCEDIMIENTO: TRANSACCION EQUIPOS (DEVOLUCION)----------------
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
*/

CREATE OR REPLACE PROCEDURE public.devolucion_equipos (integer, date, integer)
LANGUAGE 'plpgsql' AS $BODY$
DECLARE 
	 N1 int;
	BEGIN
		INSERT INTO DEVOLUCION (ASIGNACION_ID, DEVOLUCION_FECHA, DEVOLUCION_CANTIDAD) VALUES ($1, $2, $3);
		UPDATE ASIGNACION SET ASIGNACION_CANTIDAD=ASIGNACION_CANTIDAD-$3 WHERE ASIGNACION_ID = $1;
		SELECT ASIGNACION_CANTIDAD INTO N1 FROM ASIGNACION WHERE ASIGNACION.ASIGNACION_ID = $1;
		
		IF (N1 = 0) THEN
			UPDATE ASIGNACION SET ASIGNACION_ESTADO='DEVUELTO' WHERE ASIGNACION_ID = $1;
		END IF;

	EXCEPTION
		WHEN SQLSTATE '23514' THEN
		RAISE EXCEPTION 'ERROR AL INGRESAR LA CANTIDAD DE DEVOLUCION';
		ROLLBACK;
	COMMIT;
END;
$BODY$;

--CALL devolucion_equipos ('25','2021-05-12','0');
